// B+   
//     2-3  1-2  
//          
//     IP ,    .
//   count  ,      
//
//   
//
// 1)            (  )
//    .      ,    
// 2)        

#include<stdio.h>
#include<stdlib.h>
#include<memory.h>
#include<conio.h>

#define NODE_LIMIT 2000		//    
#define LIST_LIMIT 2000		//    
#define CHECK_SIZE 1000		//   
#define VOID  -1			//   
#define NODE_SIZE 7			//  
#define LIST_SIZE 7		//   (     )
#define BINARY_LIST_FIND		//   
#define BINARY_NODE_FIND		//   
//#define NODE_VOID	-1		//       
//#define LIST_VOID	-1		//       

#if LIST_SIZE<2 || NODE_SIZE<2
#error 1
#endif

struct cell_st{ int v; int p;};					//!<  
struct node_st{
#ifndef NODE_VOID
	int count; 
#endif
	cell_st arr[NODE_SIZE];
};	//!<   
struct list_st{
#ifndef LIST_VOID
	int count;
#endif
	int v[LIST_SIZE];
};	//!<  
// v   
// p   
// count  

int tree_root;	//!<    
int tree_h;		//!<  
node_st nodes[NODE_LIMIT];	//!<   
list_st list[LIST_LIMIT];	//!<   

//=====  =====

//!  
void Alarm()
{
	printf("out of memory\n");
	getchar();
	exit(-1);
}

//!   
bool isFreeNode(int index)
{
#ifdef NODE_VOID
	return nodes[index].arr[0].p==NODE_VOID;
#else
	return nodes[index].count<0;
#endif
}

//!   
bool isFreeList(int index)
{
#ifdef LIST_VOID
	return list[index].v[0]==LIST_VOID;
#else
	return list[index].count<0;
#endif
}

//!   
int NewNode()
{
	int n;
	for(n=0; n<NODE_LIMIT; n++) if(isFreeNode(n)) {
#ifdef NODE_VOID
		for(int m=0; m<NODE_SIZE; m++) nodes[n].arr[m].p=NODE_VOID;
#else
//		nodes[n].count=0;
#endif
		return n;
	}
	Alarm();
	return -1;
}

//!   
int NewList()
{
	int n;
	for(n=0; n<LIST_LIMIT; n++) if(isFreeList(n)) {
#ifdef LIST_VOID
		for(int m=0; m<LIST_SIZE; m++) list[n].v[m]=LIST_VOID;
#else
		list[n].count=0;
#endif
		return n;
	}
	Alarm();
	return -1;
}

//!  
void FreeNode(int index)
{
#ifdef NODE_VOID
	nodes[index].arr[0].p=NODE_VOID;
#else
	nodes[index].count=-1;
#endif
}

//!  
void FreeList(int index)
{
#ifdef LIST_VOID
	list[index].v[0]=LIST_VOID;
#else
	list[index].count=-1;
#endif
}


//!  
void Init()
{
	int n;
	for(n=0; n<NODE_LIMIT; n++) FreeNode(n);
	for(n=0; n<LIST_LIMIT; n++) FreeList(n);
	tree_root=NewList(); tree_h=0; 
}

//=====    =====

//!     
int GetNodeCount(int tree_index)
{
#ifdef NODE_VOID
	for(int n=0; n<NODE_SIZE; n++) if(nodes[tree_index].arr[n].p==NODE_VOID) break;
	return n;
#else
	return nodes[tree_index].count;
#endif
}

//!     
int GetListCount(int tree_index)
{
#ifdef LIST_VOID
	for(int n=0; n<LIST_SIZE; n++) if(list[tree_index].v[n]==LIST_VOID) break;
	return n;
#else
	return list[tree_index].count;
#endif
}



//!         
//! \param tree_index   
//! \param value  
//! \param coincidence =true   , =false   
int FindInList(int tree_index,int value,bool coincidence)
{
#ifdef BINARY_LIST_FIND
	int a,b,c;
#ifdef LIST_VOID
	a=0;
	b=LIST_SIZE-1;
	while(a<=b) {
		c=(a+b)/2;
		if(list[tree_index].v[c]!=LIST_VOID) a=c+1; else b=c-1;	
	}
#else
	b=list[tree_index].count-1;
#endif
	a=0;
	while(a<=b) {
		c=(a+b)/2;
		if(list[tree_index].v[c]==value) return coincidence?c:VOID;
		if(list[tree_index].v[c]<value) a=c+1; else b=c-1;	
	}
	return coincidence?VOID:a;
#else
	int i;
	for(i=0; i<list[tree_index].count; i++) {
		if(list[tree_index].v[i]==value) return coincidence?i:VOID;
		if(list[tree_index].v[i]>value) break;
	} 
	return coincidence?VOID:i;
#endif
}

//!         
//! \param tree_index   
//! \param value  
//! \param no_coincidence =true      
int FindInNode(int tree_index,int value,bool no_coincidence)
{
//	if(nodes[tree_index].count==1) return 1;
#ifdef BINARY_NODE_FIND
	int a,b,c;
#ifdef NODE_VOID
	a=0;
	b=NODE_SIZE-1;
	while(a<=b) {
		c=(a+b)/2;
		if(nodes[tree_index].arr[c].p!=NODE_VOID) a=c+1; else b=c-1;	
	}
#else
	b=nodes[tree_index].count-1;
#endif
	a=0;
	while(a<=b) {
		c=(a+b)/2;
		if(no_coincidence && nodes[tree_index].arr[c].v==value) return VOID;
		if(nodes[tree_index].arr[c].v<=value) a=c+1; else b=c-1;	
	}
	return a;
#else
	int i;
	for(i=0; i<nodes[tree_index].count; i++) {	
		if(no_coincidence && value==nodes[tree_index].arr[i].v) return VOID;
		if(value<nodes[tree_index].arr[i].v) break;
	}
	return i;
#endif
}


//!  
//! \param tree_index   
//! \param sl  ,     
//! \result   
inline int SplitList(int tree_index,int slack)
{
	int i,n=NewList();
	for(i=0; i<LIST_SIZE/2; i++) list[n].v[i]=list[tree_index].v[i+(LIST_SIZE+1)/2];
	list[n].v[i++]=slack; 
#ifdef LIST_VOID
	for(i=(LIST_SIZE+1)/2; i<LIST_SIZE; i++) list[tree_index].v[i]=LIST_VOID;
#else
	list[n].count=i;
	list[tree_index].count=(LIST_SIZE+1)/2;
#endif
	return n;
}


//!  
//! \param tree_index   
//! \param sl  ,     
//! \result   
inline int SplitNode(int tree_index,cell_st slack)
{
	int i,n=NewNode();
	for(i=0; i<NODE_SIZE/2; i++) nodes[n].arr[i]=nodes[tree_index].arr[i+(NODE_SIZE+1)/2];
	nodes[n].arr[i++]=slack; 
#ifdef NODE_VOID
	for(i=(NODE_SIZE+1)/2; i<NODE_SIZE; i++) nodes[tree_index].arr[i].p=NODE_VOID;
#else
	nodes[n].count=i;
	nodes[tree_index].count=(NODE_SIZE+1)/2;
#endif
	return n;
}



//!    
//! \param tree_index  
//! \param value  
//! \result !=VOID   ,     
inline int InsertToList(int tree_index,int value)
{
	int i,n; int slack;
	i=FindInList(tree_index,value,false); if(i==VOID) return VOID;
	slack=list[tree_index].v[LIST_SIZE-1];
#ifdef LIST_VOID
	n=LIST_SIZE-1;
#else
	n=list[tree_index].count; if(n==LIST_SIZE) n--;
#endif
	for(; n>i; n--) list[tree_index].v[n]=list[tree_index].v[n-1];
	if(i<LIST_SIZE) list[tree_index].v[i]=value; else slack=value;
#ifdef LIST_VOID
	if(slack==LIST_VOID) return VOID;
#else
	list[tree_index].count++;
	if(list[tree_index].count<=LIST_SIZE) return VOID;
#endif
	return SplitList(tree_index,slack);
}

//!    
//! \param tree_index  
//! \param i      
//! \param ref  
//! \param min   
//! \result !=VOID   ,     
inline int InsertToNode(int tree_index,int i,int ref,int min)
{
	int n;
	cell_st slack_n;
	slack_n=nodes[tree_index].arr[NODE_SIZE-1];
#ifdef NODE_VOID
	n=NODE_SIZE-1;
#else
	n=nodes[tree_index].count; if(n==NODE_SIZE) n--;
#endif
	for(; n>i+1; n--) nodes[tree_index].arr[n]=nodes[tree_index].arr[n-1];
	if(i<NODE_SIZE-1) nodes[tree_index].arr[i+1].v=min,nodes[tree_index].arr[i+1].p=ref;
	else slack_n.p=ref,slack_n.v=min;
#ifdef NODE_VOID
	if(slack_n.p==NODE_VOID) return VOID;
#else
	nodes[tree_index].count++;
	if(nodes[tree_index].count<=NODE_SIZE) return VOID;
#endif
	return SplitNode(tree_index,slack_n);
}

//!   
//! \param i1   ( )
//! \param i2   ( )
inline void MergeList(int i1,int i2)
{
	int n,m;
	n=GetListCount(i1);
#ifdef LIST_VOID
	for(m=0; m<LIST_SIZE && n<LIST_SIZE; m++,n++) {
		if(list[i2].v[m]==LIST_VOID) break;
		list[i1].v[n]=list[i2].v[m];
	}
#else
	for(m=0; m<list[i2].count && n<LIST_SIZE; m++,n++) list[i1].v[n]=list[i2].v[m];
	list[i1].count=n;
#endif
	FreeList(i2);
}

//!   
//! \param i1   ( )
//! \param i2   ( )
inline void MergeNode(int i1,int i2)
{
	int n,m;
	n=GetNodeCount(i1);
#ifdef NODE_VOID
	for(m=0; m<NODE_SIZE && n<NODE_SIZE; m++,n++) {
		if(nodes[i2].arr[m].p==NODE_VOID) break;
		nodes[i1].arr[n]=nodes[i2].arr[m];
	}
#else
	for(m=0; m<nodes[i2].count && n<NODE_SIZE; m++,n++) nodes[i1].arr[n]=nodes[i2].arr[m];
	nodes[i1].count=n;
#endif
	FreeNode(i2);
}


//!    
//! \param tree_index    
//! \param i   
inline RemoveFromNode(int tree_index,int i)
{
	int n;
#ifdef NODE_VOID
	for(n=i; n<NODE_SIZE-1; n++) nodes[tree_index].arr[n]=nodes[tree_index].arr[n+1];
	nodes[tree_index].arr[NODE_SIZE-1].p=NODE_VOID;
#else
	for(n=i; n<nodes[tree_index].count-1; n++) nodes[tree_index].arr[n]=nodes[tree_index].arr[n+1];
	nodes[tree_index].count--;
#endif
}

//!   
inline void PourNodeL(int index1,int index2)
{
//	return;
#ifdef NODE_VOID
	int n=GetNodeCount(index1);
	if(n>NODE_SIZE) _asm { int 3 }
	nodes[index1].arr[n]=nodes[index2].arr[0];
#else
	if(nodes[index1].count>=NODE_SIZE) _asm { int 3 }
	nodes[index1].arr[nodes[index1].count++]=nodes[index2].arr[0];
#endif
	RemoveFromNode(index2,0);
}

//!   
inline void PourNodeR(int index1,int index2)
{
//	return;
	int n;
#ifdef NODE_VOID
	n=GetNodeCount(index1)-1;
#else
	n=--nodes[index1].count;
#endif
	if(n<0) _asm { int 3 }
	InsertToNode(index2,-1,nodes[index1].arr[n].p,nodes[index1].arr[n].v);
#ifdef NODE_VOID
	nodes[index1].arr[n].p=NODE_VOID;
#endif
}

//!   
inline void PourListL(int index1,int index2)
{
#ifdef LIST_VOID
	int m,n;
	n=GetListCount(index1);
	if(n>=LIST_SIZE) _asm { int 3 }
	list[index1].v[n]=list[index2].v[0];
	for(m=1; m<LIST_SIZE; m++) list[index2].v[m-1]=list[index2].v[m];
	list[index2].v[LIST_SIZE-1]=LIST_VOID;
#else
	int n;
	if(list[index1].count>=LIST_SIZE) _asm { int 3 }
	list[index1].v[list[index1].count++]=list[index2].v[0];
	for(n=1; n<list[index2].count; n++) list[index2].v[n-1]=list[index2].v[n];
	list[index2].count--;
#endif
}

//!   
inline void PourListR(int index1,int index2)
{
	int n;
#ifdef LIST_VOID
	if(list[index2].v[LIST_SIZE-1]!=LIST_VOID || list[index1].v[0]==LIST_VOID) _asm { int 3 }
	for(n=LIST_SIZE-1;n;n--) list[index2].v[n]=list[index2].v[n-1]; 
	n=GetListCount(index1)-1;
	list[index2].v[0]=list[index1].v[n];
	list[index1].v[n]=LIST_VOID;
#else
	if(list[index2].count>=LIST_SIZE) _asm { int 3 }
	for(n=list[index2].count;n;n--) list[index2].v[n]=list[index2].v[n-1]; 
	list[index1].count--; list[index2].count++;
	list[index2].v[0]=list[index1].v[list[index1].count];	
#endif
}

//!     ,    
//! \param tree_index    
//! \param depth 
//! \param i1     (   )
//! \param i2     
bool GetNeighbour(int tree_index,int depth,int *i1,int *i2)
{
	int mask=0;
	int ref1,ref2,count1,count2;
	if(*i1>0) mask|=1;
#ifdef NODE_VOID
	if(*i1<NODE_SIZE-1 && nodes[tree_index].arr[1+*i1].p!=NODE_VOID) mask|=2;
#else
	if(*i1<nodes[tree_index].count-1) mask|=2;
#endif
	switch(mask) {
	case 0: return true;
	case 1: *i2=(*i1)--; break;
	case 2: *i2=1+*i1; break;
	case 3: 
		ref1=nodes[tree_index].arr[(*i1)-1].p;
		ref2=nodes[tree_index].arr[(*i1)+1].p;
		if(depth==tree_h-1) count1=GetListCount(ref1),count2=GetListCount(ref2);
		else count1=GetNodeCount(ref1),count2=GetNodeCount(ref2);
		if(count1<count2) *i2=1+*i1; else *i2=(*i1)--; break;
	}
	return false;
}


//=====     =====

//!  ,  
//! \param tree_index  
//! \param depth 
void Show(int tree_index,int depth)
{
	int n,m;
	for(n=0; n<depth*2; n++) putchar(' ');
	if(depth==tree_h) {
		printf("l%d:",tree_index);
#ifdef LIST_VOID
		for(n=0; n<LIST_SIZE; n++) if(list[tree_index].v[n]!=LIST_VOID) printf(" %d",list[tree_index].v[n]); else break;
#else
		for(n=0; n<list[tree_index].count; n++) printf(" %d",list[tree_index].v[n]);
#endif
		putchar('\n');
		return;
	}
	printf("n%d: ",tree_index);
#ifdef NODE_VOID
	for(m=0; m<NODE_SIZE; m++) {
		if(nodes[tree_index].arr[m].p==NODE_VOID) break;
		//if(m) 
			printf("[%d]",nodes[tree_index].arr[m].v);
		printf("%d",nodes[tree_index].arr[m].p);
	}
	putchar('\n');
	for(n=0; n<NODE_SIZE; n++) if(nodes[tree_index].arr[n].p!=NODE_VOID)Show(nodes[tree_index].arr[n].p,depth+1); else break;
#else
	for(m=0; m<nodes[tree_index].count; m++) {
		if(m) printf("[%d]",nodes[tree_index].arr[m].v);
		printf("%d",nodes[tree_index].arr[m].p);
	}
	putchar('\n');
	for(n=0; n<nodes[tree_index].count; n++) Show(nodes[tree_index].arr[n].p,depth+1);
#endif
}

//!   (        )
//!       ,     
//! \param tree_index    
//! \param i1    (   )
//! \param depth 
void Balance(int tree_index,int i1,int depth)
{
	int ref1,ref2,count1,count2,i2;
	//      (    )
#if NODE_SIZE<3 // 1-2 
	ref1=nodes[tree_index].arr[i1].p;
	if(depth==tree_h-1 && !list[ref1].count || depth<tree_h-1 && !nodes[ref1].count) {
		RemoveFromNode(tree_index,i1);
		if(depth==tree_h-1) FreeList(ref1); else FreeNode(ref1);
		return;
	}
#endif
	if(GetNeighbour(tree_index,depth,&i1,&i2)) return;
	ref1=nodes[tree_index].arr[i1].p;
	ref2=nodes[tree_index].arr[i2].p;
	if(depth==tree_h-1) { //   ,      
		count1=GetListCount(ref1);
		count2=GetListCount(ref2);
		if(count1+count2<=LIST_SIZE) { //    
			MergeList(ref1,ref2);
			RemoveFromNode(tree_index,i2);
#if LIST_SIZE==2
			nodes[tree_index].arr[i1].v=list[ref1].v[0];
#endif
		} else
			if(abs(count1-count2)>1) { //  
			if(count1>count2) PourListR(ref1,ref2); else PourListL(ref1,ref2);
			nodes[tree_index].arr[i2].v=list[ref2].v[0];
		}
	} else {
		count1=GetNodeCount(ref1);
		count2=GetNodeCount(ref2);
		if(count1+count2<=NODE_SIZE) {	//  
			MergeNode(ref1,ref2);
			RemoveFromNode(tree_index,i2);
#if NODE_SIZE<3	// 1-2 
			nodes[tree_index].arr[i1].v=nodes[ref1].arr[0].v;
#endif
		}else
		if(abs(count1-count2)>1) { //  
			if(count1>count2) PourNodeR(ref1,ref2); else PourNodeL(ref1,ref2);
			nodes[tree_index].arr[i2].v=nodes[ref2].arr[0].v;
		}
	}
}

//!  ,  
//! \param tree_index    
//! \param depth 
//! \param value  
//! \result     
int InsertSub(int tree_index,int depth,int value)
{
	static int min1,min2;
	int n,m,i1; 
	if(depth==tree_h) {	
		//     
		i1=InsertToList(tree_index,value); 
		min1=list[tree_index].v[0];
		if(i1==VOID) return VOID;
		min2=list[i1].v[0];
		goto exit;
	}
	//           (    )
	min1=nodes[tree_index].arr[0].v;
	i1=FindInNode(tree_index,value,true); if(i1==VOID) return VOID;
	if(i1) i1--;
	m=InsertSub(nodes[tree_index].arr[i1].p,depth+1,value); //   
	nodes[tree_index].arr[i1].v=min1;
	min1=nodes[tree_index].arr[0].v;
	if(m==VOID) {
		Balance(tree_index,i1,depth);
		return VOID;
	}
	//     
	i1=InsertToNode(tree_index,i1,m,min2); 
	if(i1==VOID) return VOID;
	min2=nodes[i1].arr[0].v;
exit:
	if(depth) return i1;	//   ,    .
	n=NewNode(); tree_h++;
#ifndef NODE_VOID
	nodes[n].count=2;
#endif
	nodes[n].arr[0].p=tree_root;
	nodes[n].arr[1].p=i1;
	nodes[n].arr[0].v=min1;
	nodes[n].arr[1].v=min2;
	tree_root=n;
	return VOID;
}


//!  ,  
//! \param tree_index   
//! \param depth 
//! \param value 
void RemoveSub(int tree_index,int depth,int value)
{
	static int min;
	int n,i1;
	if(depth==tree_h) {	
		//   ,    
		n=FindInList(tree_index,value,true);
		if(n!=VOID) { 
#ifdef LIST_VOID
			for(;n<LIST_SIZE-1; n++) list[tree_index].v[n]=list[tree_index].v[n+1]; 
			list[tree_index].v[LIST_SIZE-1]=LIST_VOID;
#else
			for(;n<list[tree_index].count-1; n++) list[tree_index].v[n]=list[tree_index].v[n+1]; 
			list[tree_index].count--;
#endif
		}
		min=list[tree_index].v[0];
		return;
	}
	//     ,     
	i1=FindInNode(tree_index,value,false); //if(i1==VOID) return;
	i1--; if(i1<0) return;
	RemoveSub(nodes[tree_index].arr[i1].p,depth+1,value); //   
	nodes[tree_index].arr[i1].v=min;
	Balance(tree_index,i1,depth);
	min=nodes[tree_index].arr[0].v;
}

//=====   (   ) =====

//!  
void Show()
{
	printf("[show]\n");
	Show(tree_root,0);
}

//!    
//! \param value  
void Insert(int value)
{
	printf("insert: %d\n",value);
	InsertSub(tree_root,0,value); 
}

//!   
//! \param value  
void Remove(int value)
{
	int n;
	printf("remove: %d\n",value);
	RemoveSub(tree_root,0,value);
	while(tree_h>0) { //      ,   
#ifdef NODE_VOID
		if(nodes[tree_root].arr[1].p!=NODE_VOID) break;
#else
		if(nodes[tree_root].count!=1) break;
#endif
		n=tree_root; tree_root=nodes[tree_root].arr[0].p;
		FreeNode(n);
		tree_h--;
	}
}


//=====    ======

//     
enum MapCode{
MAPCODE_FREE	=0,	//  
MAPCODE_USE		=1,	//  
MAPCODE_USEOK	=2,	//     
MAPCODE_ERR		=3	//  ,    
};

MapCode map[CHECK_SIZE]; //!<     

//!     ,  
//! \param tree_index   
//! \param depth 
void CheckMap(int tree_index,int depth)
{
	int n,v;
	if(depth==tree_h) {
#ifdef LIST_VOID
		for(n=0; n<LIST_SIZE; n++) { 
			v=list[tree_index].v[n]; if(v==LIST_VOID) break;
			map[v]=map[v]==MAPCODE_USE?MAPCODE_USEOK:MAPCODE_ERR;
		}
#else
		for(n=0; n<list[tree_index].count; n++) { 
			v=list[tree_index].v[n];
			map[v]=map[v]==MAPCODE_USE?MAPCODE_USEOK:MAPCODE_ERR;
		}
#endif
		return;
	}
#ifdef NODE_VOID
	for(n=0; n<NODE_SIZE; n++) if(nodes[tree_index].arr[n].p!=NODE_VOID) CheckMap(nodes[tree_index].arr[n].p,depth+1); else break;
#else
	for(n=0; n<nodes[tree_index].count; n++) CheckMap(nodes[tree_index].arr[n].p,depth+1);
#endif
}

//!     
//!   
void CheckMap()
{
	int n;
	CheckMap(tree_root,0);
	for(n=0; n<CHECK_SIZE; n++) switch(map[n]) {
	case MAPCODE_FREE: break;
	case MAPCODE_USEOK: map[n]=MAPCODE_USE; break;
	default: _asm { int 3 }
	}
}


//!   ,  
//! \param tree_index   
//! \param seed     (     )
//! \param depth 
//! \result     
int Check(int tree_index,int *seed,int depth)
{
	int n,r,t;
	if(depth==tree_h) {
#ifdef LIST_VOID
		for(n=0; n<LIST_SIZE; n++) {
			if(list[tree_index].v[n]==LIST_VOID) break;
			if(list[tree_index].v[n]<0 || list[tree_index].v[n]>=CHECK_SIZE) _asm { int 3 }
			if(*seed<list[tree_index].v[n]) *seed=list[tree_index].v[n]; else _asm { int 3 }
		}
		if(tree_h && n<LIST_SIZE/2) _asm { int 3 }
#else
		if(tree_h && list[tree_index].count<LIST_SIZE/2) _asm { int 3 }
		for(n=0; n<list[tree_index].count; n++) {
			if(list[tree_index].v[n]<0 || list[tree_index].v[n]>=CHECK_SIZE) _asm { int 3 }
			if(*seed<list[tree_index].v[n]) *seed=list[tree_index].v[n]; else _asm { int 3 }
		}
#endif
		return list[tree_index].v[0];
	}
	r=-1;
#ifdef NODE_VOID
	for(n=0; n<NODE_SIZE; n++) {
		if(nodes[tree_index].arr[n].p==NODE_VOID) break;
		t=Check(nodes[tree_index].arr[n].p,seed,depth+1);
		if(!n) r=t;
		if(nodes[tree_index].arr[n].v!=t) _asm { int 3 }
	}
	if(depth && n<NODE_SIZE/2) _asm { int 3 }
#else
	if(depth && nodes[tree_index].count<NODE_SIZE/2) _asm { int 3 }
	for(n=0; n<nodes[tree_index].count; n++) {
		t=Check(nodes[tree_index].arr[n].p,seed,depth+1);
		if(!n) r=t;
		if(nodes[tree_index].arr[n].v!=t) _asm { int 3 }
	}
#endif
	return r;
}


//!   
//!          
//!       
//!          
//!   
void Check()
{
	int n;
	for(n=0; n<LIST_LIMIT; n++) if(GetListCount(n)>LIST_SIZE) _asm { int 3 }
	for(n=0; n<NODE_LIMIT; n++) if(GetNodeCount(n)>NODE_SIZE) _asm { int 3 }
	int value=-99;
	Check(tree_root,&value,0);
}


//=============================================================================




void main()
{
	int n,v;
	Init();
	memset(map,MAPCODE_FREE,sizeof(map));
	for(n=0;;n++) 
	{
		printf("[pass: %d]\n",n);
		v=rand()%CHECK_SIZE; map[v]=MAPCODE_USE;  
		Insert(v);
		Check();
		CheckMap();
		v=rand()%CHECK_SIZE; map[v]=MAPCODE_FREE;
		Remove(v);
		if(!(n%5000)) {
			Show();
		}
		Check();
		CheckMap();
		if(_kbhit()) break;
	}
	//  
	printf("wipe teee\n");
	for(n=0; n<CHECK_SIZE; n++) if(map[n]) Remove(n);
	if(tree_h) printf("error (h>0)\n"); else if(tree_root!=VOID) FreeList(tree_root);	
	//    
	for(n=0; n<LIST_LIMIT; n++) if(!isFreeList(n)) printf("leak list: %d\n\a",n);
	for(n=0; n<NODE_LIMIT; n++) if(!isFreeNode(n)) printf("leak node: %d\n\a",n);
	printf("[done]\n");
	getchar();
	getchar();
}






